diff -uwrN sourceold/scripts/tcw_vehicle.h source/scripts/tcw_vehicle.h
--- sourceold/scripts/tcw_vehicle.h	2012-06-09 08:11:12.201171800 +0800
+++ source/scripts/tcw_vehicle.h	2012-07-31 21:54:12.119140600 +0800
@@ -20,11 +20,16 @@
 	public: void Register_Auto_Save_Variables();
 	void Killed(GameObject *obj, GameObject *shooter);
 	void Damaged(GameObject *obj, GameObject *damager, float damage);
+	void Destroyed(GameObject *obj);
 	bool triggerstealthdetection;
 	bool revealed;
 	bool playdetected;
 	bool playdamage;
 	bool is_railgun_available;
+	int venomfxid;
+	int gharv_idle_fxid;
+	int gharv_harving_fxid;
+	int gharv_full_fxid;
 };
 
 class tcw_vehexit_killtimer : public ScriptImpClass {
@@ -35,3 +40,39 @@
 	int timerid;
 	int driverid;
 };
+
+class tcw_hijacked_nod : public ScriptImpClass {
+	void Custom(GameObject *obj, int message, int param, GameObject *sender);
+}; 
+class tcw_hijacked_gdi: public ScriptImpClass {
+	void Custom(GameObject *obj, int message, int param, GameObject *sender);
+}; 
+
+class tcw_bunker : public ScriptImpClass
+{
+	void Created(GameObject *obj);
+	void Damaged(GameObject *obj,GameObject *damager,float amount);
+	int ZoneID;
+};
+
+class tcw_bunker_zone : public ScriptImpClass
+{
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+	int ExpLoc1;
+	int ExpLoc2;
+	int ExpLoc3;
+};
+
+class tcw_apc_minefield_lay : public ScriptImpClass
+{
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+	void Timer_Expired(GameObject *obj, int number);
+	bool Minefield_Available;
+};
+
+class tcw_apc_minefield : public ScriptImpClass
+{
+	void Entered(GameObject *obj, GameObject *enter);
+};
\ No newline at end of file
diff -uwrN sourceold/scripts/tcw_zone.cpp source/scripts/tcw_zone.cpp
--- sourceold/scripts/tcw_zone.cpp	2012-06-09 08:11:12.308593700 +0800
+++ source/scripts/tcw_zone.cpp	2012-07-31 21:54:12.208984300 +0800
@@ -69,7 +69,7 @@
 		}
 
 		//check if they are orca or firehawk and give powerups
-		if (strcmp(Commands->Get_Preset_Name(Commands->Find_Object(number)),"TCW_GDI_Orca") == 0)
+		if ( (strcmp(Commands->Get_Preset_Name(Commands->Find_Object(number)),"TCW_GDI_Orca") == 0) || (strcmp(Commands->Get_Preset_Name(Commands->Find_Object(number)),"TCW_Paul_Orca") == 0) )
 		{
 			Commands->Give_PowerUp(Commands->Find_Object(number),"TCW_POW_Orca_Rocket",true);
 		}
@@ -82,5 +82,13 @@
 	}
 }
 
+void tcw_zone_kill_soldier_stars::Entered(GameObject *obj, GameObject *enter)
+{
+	if (enter->As_SoldierGameObj() && Commands->Is_A_Star(enter))
+	{
+		Commands->Apply_Damage(enter,99999.0f,"Death",enter);
+	}
+}
 
+ScriptRegistrant<tcw_zone_kill_soldier_stars> tcw_zone_kill_soldier_stars_Registrant("tcw_zone_kill_soldier_stars","");
 ScriptRegistrant<tcw_GDI_Zone_Aircraft_Only> tcw_GDI_Zone_Aircraft_Only_Registrant("tcw_GDI_Zone_Aircraft_Only","");
\ No newline at end of file
diff -uwrN sourceold/scripts/tcw_zone.h source/scripts/tcw_zone.h
--- sourceold/scripts/tcw_zone.h	2012-06-09 08:11:12.164062500 +0800
+++ source/scripts/tcw_zone.h	2012-07-31 21:54:12.048828100 +0800
@@ -18,3 +18,6 @@
 	void Timer_Expired(GameObject *obj,int number);
 };
 
+class tcw_zone_kill_soldier_stars : public ScriptImpClass {
+	void Entered(GameObject *obj,GameObject *enter);
+};
diff -uwrN sourceold/scripts/xpert.cpp source/scripts/xpert.cpp
--- sourceold/scripts/xpert.cpp	1970-01-01 08:00:00.000000000 +0800
+++ source/scripts/xpert.cpp	2012-07-28 09:11:06.227539000 +0800
@@ -0,0 +1,73 @@
+/*	  Renegade Scripts.dll
+		Copyright 2011 Tiberian Technologies
+ 
+		This file is part of the Renegade scripts.dll
+		The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+		the terms of the GNU General Public License as published by the Free
+		Software Foundation; either version 2, or (at your option) any later
+		version. See the file COPYING for more details.
+		In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+		Only the source code to the module(s) containing the licenced code has to be released.
+*/
+ 
+#include "General.h"
+#include "Xpert.h"
+#include "engine.h"
+#include "PhysClass.h"
+#include "PhysicalGameObj.h"
+#pragma warning(disable: 4996)
+
+Xpert_Teleport_Zone_Random::Xpert_Teleport_Zone_Random() : NextLocation(0)
+{
+}
+ 
+void Xpert_Teleport_Zone_Random::Entered(GameObject* Zone, GameObject* Enterer)
+{
+		Vector3 Location;
+		int ObjectId;
+	   
+		switch (NextLocation)
+		{
+				case 0:
+						Location = Get_Vector3_Parameter("Location1");
+						ObjectId = Get_Int_Parameter("Object_ID1");
+						break;
+				case 1:
+						Location = Get_Vector3_Parameter("Location2");
+						ObjectId = Get_Int_Parameter("Object_ID2");
+						break;
+				case 2:
+						Location = Get_Vector3_Parameter("Location3");
+						ObjectId = Get_Int_Parameter("Object_ID3");
+						break;
+				case 3:
+						Location = Get_Vector3_Parameter("Location4");
+						ObjectId = Get_Int_Parameter("Object_ID4");
+						break;
+				case 4:
+						Location = Get_Vector3_Parameter("Location5");
+						ObjectId = Get_Int_Parameter("Object_ID5");
+						break;
+				default:
+						return; // Should never happen
+		}
+		if (ObjectId)
+		{
+				Location = Commands->Get_Position(Commands->Find_Object(ObjectId));
+		}
+	   
+			Commands->Set_Position(Enterer, Location);
+		if (Enterer->As_PhysicalGameObj() && Enterer->As_PhysicalGameObj()->Peek_Physical_Object())
+		{
+				Enterer->As_PhysicalGameObj()->Peek_Physical_Object()->Set_Collision_Group(SOLDIER_GHOST_COLLISION_GROUP);
+		}
+	   
+		NextLocation = (NextLocation + 1) % 5;
+}
+ 
+void Xpert_Teleport_Zone_Random::Register_Auto_Save_Variables()
+{
+		Auto_Save_Variable(&NextLocation, sizeof(NextLocation), 1);
+}
+
+ScriptRegistrant<Xpert_Teleport_Zone_Random> Xpert_Teleport_Zone_Random_Registrant("Xpert_Teleport_Zone_Random", "Location1:vector3,Object_ID1=0:int,Location2:vector3,Object_ID2=0:int,Location3:vector3,Object_ID3=0:int,Location4:vector3,Object_ID4=0:int,Location5:vector3,Object_ID5=0:int");
diff -uwrN sourceold/scripts/xpert.h source/scripts/xpert.h
--- sourceold/scripts/xpert.h	1970-01-01 08:00:00.000000000 +0800
+++ source/scripts/xpert.h	2012-07-28 09:11:05.930664000 +0800
@@ -0,0 +1,21 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
+#include "scripts.h"
+ 
+class Xpert_Teleport_Zone_Random : public ScriptImpClass
+{
+public:
+	int NextLocation;
+	Xpert_Teleport_Zone_Random();
+	void Entered(GameObject* Zone, GameObject* Enterer);
+	void Register_Auto_Save_Variables();
+};
